diff --git a/Makefile b/Makefile
index 9e74b972..288becab 100644
--- a/Makefile
+++ b/Makefile
@@ -34,7 +34,7 @@ OBJS =  x11-ui.o config.o util.o geometry.o isprog.o sbuf.o icon-find.o \
         icon.o xpm-loader.o xdgdirs.o xdgapps.o xsettings.o xsettings-helper.o \
 	filter.o compat.o hashmap.o lockfile.o argv-buf.o t2conf.o t2env.o \
 	unix_sockets.o bl.o cache.o back.o terminal.o restart.o theme.o \
-	gtkconf.o font.o args.o widgets.o pm.o socket.o
+	gtkconf.o font.o args.o widgets.o pm.o socket.o fmt.o
 
 SRCS = $(patsubst %.o,%.c,$(OBJS))
 JGMENU_LIB = libjgmenu.a
@@ -46,7 +46,7 @@ jgmenu-xdg: jgmenu-xdg.o util.o sbuf.o xdgdirs.o xdgapps.o argv-buf.o
 jgmenu-ob: jgmenu-ob.o util.o sbuf.o
 jgmenu-socket: jgmenu-socket.o util.o sbuf.o unix_sockets.o socket.o
 ifneq ($(NO_LX),1)
-jgmenu-lx: jgmenu-lx.o util.o sbuf.o xdgdirs.o argv-buf.o back.o
+jgmenu-lx: jgmenu-lx.o util.o sbuf.o xdgdirs.o argv-buf.o back.o fmt.o
 endif
 $(PROGS):
 	$(QUIET_LINK)$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
diff --git a/fmt.c b/fmt.c
new file mode 100644
index 00000000..e2f1be75
--- /dev/null
+++ b/fmt.c
@@ -0,0 +1,20 @@
+#include <stdio.h>
+#include <stdlib.h>
+
+#include "sbuf.h"
+#include "fmt.h"
+
+void fmt_name(struct sbuf *buf, const char *name, const char *generic_name)
+{
+	sbuf_cpy(buf, "");
+	if (!name)
+		return;
+	sbuf_addstr(buf, name);
+	if (!generic_name)
+		return;
+	if (!strcmp(name, generic_name))
+		return;
+	sbuf_addstr(buf, " (");
+	sbuf_addstr(buf, generic_name);
+	sbuf_addstr(buf, ")");
+}
diff --git a/fmt.h b/fmt.h
new file mode 100644
index 00000000..99f18f99
--- /dev/null
+++ b/fmt.h
@@ -0,0 +1,8 @@
+#ifndef FMT_H
+#define FMT_H
+
+#include "sbuf.h"
+
+void fmt_name(struct sbuf *buf, const char *name, const char *generic_name);
+
+#endif /* FMT_H */
diff --git a/jgmenu-lx.c b/jgmenu-lx.c
index 171e6ef3..86b6f7fb 100644
--- a/jgmenu-lx.c
+++ b/jgmenu-lx.c
@@ -10,6 +10,7 @@
 #include "list.h"
 #include "back.h"
 #include "xdgdirs.h"
+#include "fmt.h"
 
 struct menu {
 	struct sbuf buf;
@@ -73,8 +74,16 @@ static void process_app(MenuCacheApp *app)
 {
 	/* TODO: Check visibility flag here too */
 	char *p = NULL;
+	static struct sbuf s;
+	static int inited;
 
-	sbuf_addstr(&cur->buf, menu_cache_item_get_name(MENU_CACHE_ITEM(app)));
+	if (!inited) {
+		sbuf_init(&s);
+		inited = 1;
+	}
+	fmt_name(&s, menu_cache_item_get_name(MENU_CACHE_ITEM(app)),
+		 menu_cache_app_get_generic_name(MENU_CACHE_APP(app)));
+	sbuf_addstr(&cur->buf, s.buf);
 	sbuf_addstr(&cur->buf, ",");
 	if (menu_cache_app_get_use_terminal(app))
 		sbuf_addstr(&cur->buf, "^term(");
